
/*
**	This file contains routines for working with labeling an image.
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <windows.h>
#include "resource.h"
#include "globals.h"



LRESULT CALLBACK EditLabelProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)

{
static int	Threshold;
SCROLLINFO	BarInfo;
BOOL		Success;
static HWND	RedScrollHwnd,GreenScrollHwnd,BlueScrollHwnd;
RECT		ColorRect;
HDC			hDC;
HBRUSH		ColorBrush;
int			i;

switch(uMsg)
  {
  case WM_INITDIALOG:
	SetDlgItemInt(hDlg,ID_EDIT_VALUE,Label,FALSE);
	BarInfo.cbSize=sizeof(SCROLLINFO);
	BarInfo.nMin=0;
	BarInfo.nMax=255;
	BarInfo.nPos=LabelColor[Label][0];
	BarInfo.fMask=SIF_POS | SIF_RANGE;
	RedScrollHwnd=GetDlgItem(hDlg,ID_SCROLL_RED);
	SetScrollInfo(RedScrollHwnd,SB_CTL,&BarInfo,TRUE);
	BarInfo.nPos=LabelColor[Label][1];
	GreenScrollHwnd=GetDlgItem(hDlg,ID_SCROLL_GREEN);
	SetScrollInfo(GreenScrollHwnd,SB_CTL,&BarInfo,TRUE);
	BarInfo.nPos=LabelColor[Label][2];
	BlueScrollHwnd=GetDlgItem(hDlg,ID_SCROLL_BLUE);
	SetScrollInfo(BlueScrollHwnd,SB_CTL,&BarInfo,TRUE);
	ColorRect.top=118; ColorRect.bottom=133; ColorRect.left=120; ColorRect.right=160;
	ColorBrush=CreateSolidBrush(RGB(LabelColor[Label][0],LabelColor[Label][1],LabelColor[Label][2]));
	hDC=GetDC(hDlg);
	FillRect(hDC,&ColorRect,ColorBrush);
	ReleaseDC(hDlg,hDC);
	DeleteObject(ColorBrush);
	break;
  case WM_COMMAND:
	switch(LOWORD(wParam))
	  {
	  case ID_EDIT_VALUE:
		Label=GetDlgItemInt(hDlg,ID_EDIT_VALUE,&Success,FALSE);
		if (Label < 0) Label=0;
		if (Label > 255) Label=255;
		break;
	  case IDOK:
		Label=GetDlgItemInt(hDlg,ID_EDIT_VALUE,&Success,FALSE);
		if (Label < 0) Label=0;
		if (Label > 255) Label=255;
		EndDialog(hDlg,IDOK);
		break;
	  }
	break;
  case WM_HSCROLL:
	if ((HWND)lParam == RedScrollHwnd) i=0;
	else if ((HWND)lParam == GreenScrollHwnd) i=1;
	else if ((HWND)lParam == BlueScrollHwnd) i=2;
	else break;
	if (LOWORD(wParam) == SB_LINELEFT) LabelColor[Label][i]--;
	if (LOWORD(wParam) == SB_LINERIGHT) LabelColor[Label][i]++;
	if (LOWORD(wParam) == SB_PAGELEFT) LabelColor[Label][i]-=10;
	if (LOWORD(wParam) == SB_PAGERIGHT) LabelColor[Label][i]+=10;
	if (LOWORD(wParam) == SB_THUMBPOSITION) LabelColor[Label][i]=HIWORD(wParam);
	if (LabelColor[Label][i] < 0) LabelColor[Label][i]=0;
	if (LabelColor[Label][i] > 255) LabelColor[Label][i]=255;
	BarInfo.cbSize=sizeof(SCROLLINFO);
	BarInfo.fMask=SIF_POS;
	BarInfo.nPos=LabelColor[Label][i];
	if (i == 0)	SetScrollInfo(RedScrollHwnd,SB_CTL,&BarInfo,TRUE);
	else if (i == 1) SetScrollInfo(GreenScrollHwnd,SB_CTL,&BarInfo,TRUE);
	else SetScrollInfo(BlueScrollHwnd,SB_CTL,&BarInfo,TRUE);
	ColorRect.top=118; ColorRect.bottom=133; ColorRect.left=120; ColorRect.right=160;
	ColorBrush=CreateSolidBrush(RGB(LabelColor[Label][0],LabelColor[Label][1],LabelColor[Label][2]));
	hDC=GetDC(hDlg);
	FillRect(hDC,&ColorRect,ColorBrush);
	ReleaseDC(hDlg,hDC);
	DeleteObject(ColorBrush);
	break;
  default:
	return(FALSE);
  }
return(TRUE);
}



